Liferay.Loader.define("dynamic-data-mapping-form-renderer@5.0.35/js/components/AutoFocus.es", ['module', 'exports', 'require', 'frontend-js-react-web$react', '../hooks/usePage.es'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.AutoFocus = void 0;

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _usePage2 = require("../hooks/usePage.es");

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { "default": obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj["default"] = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    var AutoFocus = function AutoFocus(_ref) {
      var _children$props, _children$props$child, _children$props$child2;

      var children = _ref.children;
      var childRef = (0, _react.useRef)();

      var _usePage = (0, _usePage2.usePage)(),
          activePage = _usePage.activePage,
          containerElement = _usePage.containerElement; // This is a hack to know when FieldLazy is ready.


      var lazyStatus = children === null || children === void 0 ? void 0 : (_children$props = children.props) === null || _children$props === void 0 ? void 0 : (_children$props$child = _children$props.children) === null || _children$props$child === void 0 ? void 0 : (_children$props$child2 = _children$props$child.type) === null || _children$props$child2 === void 0 ? void 0 : _children$props$child2._status;
      (0, _react.useLayoutEffect)(function () {
        if (childRef.current && (containerElement === null || containerElement === void 0 ? void 0 : containerElement.current)) {
          var firstInput = childRef.current.querySelector('input');

          if (firstInput && !containerElement.current.contains(document.activeElement)) {
            firstInput.focus();

            if (firstInput.select) {
              firstInput.select();
            }
          }
        }
      }, [activePage, childRef, containerElement, lazyStatus]);
      return _react["default"].cloneElement(children, {
        ref: function ref(node) {
          childRef.current = node;
        }
      });
    };

    exports.AutoFocus = AutoFocus;
    //# sourceMappingURL=AutoFocus.es.js.map
  }
});
//# sourceMappingURL=AutoFocus.es.js.map