<%--
/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */
--%>

<%@ include file="/init.jsp" %>

<%
User user2 = (User)request.getAttribute(ContactsWebKeys.CONTACTS_USER);

user2 = user2.toEscapedModel();

request.setAttribute("view_user.jsp-user", user2);
%>

<clay:row>
	<clay:col
		cssClass="contacts-container"
	>
		<div class="lfr-contact-thumb">
			<img alt="<%= HtmlUtil.escapeAttribute(user2.getFullName()) %>" src="<%= user2.getPortraitURL(themeDisplay) %>" />
		</div>

		<div class="lfr-contact-name">
			<%= user2.getFullName() %>
		</div>

		<div class="lfr-contact-job-title">
			<%= user2.getJobTitle() %>
		</div>

		<div class="lfr-contact-extra">
			<a href="mailto:<%= user2.getEmailAddress() %>"><%= user2.getEmailAddress() %></a>
		</div>

		<liferay-util:include page="/user/view_user_information.jsp" servletContext="<%= application %>" />
	</clay:col>
</clay:row>