Liferay.Loader.define("layout-content-page-editor-web@2.0.75/page_editor/plugins/fragments-widgets/components/SearchResultsPanel", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/alert', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react', './TabItem'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = SearchResultsPanel;

    var _alert = _interopRequireDefault(require("@frontend-taglib-clay$clayui/alert"));

    var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

    var _react = _interopRequireDefault(require("frontend-js-react-web$react"));

    var _TabItem = _interopRequireDefault(require("./TabItem"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { "default": obj };
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    function SearchResultsPanel(_ref) {
      var filteredTabs = _ref.filteredTabs;
      return filteredTabs.length ? filteredTabs.map(function (tab, index) {
        return _react["default"].createElement("div", {
          key: index
        }, _react["default"].createElement("div", {
          className: "page-editor__fragments-widgets__search-results-panel__filter-subtitle"
        }, tab.label), _react["default"].createElement("ul", {
          className: "list-unstyled"
        }, tab.collections.reduce(function (acc, collection) {
          return acc.concat(collection.children.filter(function (item) {
            return !acc.some(function (_ref2) {
              var itemId = _ref2.itemId;
              return itemId === item.itemId;
            });
          }));
        }, []).map(function (item) {
          var _item$portletItems;

          return _react["default"].createElement(_react["default"].Fragment, {
            key: item.itemId
          }, _react["default"].createElement(_TabItem["default"], {
            item: item,
            key: item.itemId
          }), ((_item$portletItems = item.portletItems) === null || _item$portletItems === void 0 ? void 0 : _item$portletItems.length) && _react["default"].createElement(TabPortletItem, {
            item: item
          }));
        })));
      }) : _react["default"].createElement(_alert["default"], {
        displayType: "info",
        title: Liferay.Language.get('info')
      }, Liferay.Language.get('there-are-no-fragments-or-widgets-on-this-page'));
    }

    var TabPortletItem = function TabPortletItem(_ref3) {
      var item = _ref3.item;
      return item.portletItems.map(function (portlet, index) {
        return _react["default"].createElement(_TabItem["default"], {
          item: portlet,
          key: index
        });
      });
    };

    SearchResultsPanel.proptypes = {
      filteredTabs: _propTypes["default"].object.isRequired
    };
    //# sourceMappingURL=SearchResultsPanel.js.map
  }
});
//# sourceMappingURL=SearchResultsPanel.js.map