Liferay.Loader.define("dynamic-data-mapping-form-renderer@5.0.35/js/components/PageRenderer/EditablePageHeader.es", ['module', 'exports', 'require', 'frontend-js-react-web$react'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.PageHeader = void 0;

    var _react = _interopRequireDefault(require("frontend-js-react-web$react"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { "default": obj };
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    var PageHeader = function PageHeader(_ref) {
      var description = _ref.description,
          placeholder = _ref.placeholder,
          title = _ref.title;
      return _react["default"].createElement("div", null, _react["default"].createElement("input", {
        className: "form-builder-page-header-title form-control p-0",
        defaultValue: title,
        maxLength: "120",
        placeholder: placeholder,
        value: title
      }), _react["default"].createElement("input", {
        className: "form-builder-page-header-description form-control p-0",
        defaultValue: description,
        maxLength: "120",
        placeholder: Liferay.Language.get('add-a-short-description-for-this-page'),
        value: description
      }));
    };

    exports.PageHeader = PageHeader;
    //# sourceMappingURL=EditablePageHeader.es.js.map
  }
});
//# sourceMappingURL=EditablePageHeader.es.js.map