Liferay.Loader.define("layout-content-page-editor-web@2.0.75/page_editor/plugins/experience/actions/deleteExperience", ['module', 'exports', 'require', './types'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = deleteExperience;

    var _types = require("./types");

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    function deleteExperience(_ref) {
      var portletIds = _ref.portletIds,
          segmentsExperienceId = _ref.segmentsExperienceId;
      return {
        payload: {
          portletIds: portletIds,
          segmentsExperienceId: segmentsExperienceId
        },
        type: _types.DELETE_SEGMENTS_EXPERIENCE
      };
    }
    //# sourceMappingURL=deleteExperience.js.map
  }
});
//# sourceMappingURL=deleteExperience.js.map