Liferay.Loader.define("layout-content-page-editor-web@2.0.75/page_editor/plugins/experience/thunks/updateExperiencePriority", ['module', 'exports', 'require', '../../../app/services/ExperienceService', '../actions/updateExperiencePriority'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = updateExperiencePriority;

    var _ExperienceService = _interopRequireDefault(require("../../../app/services/ExperienceService"));

    var _updateExperiencePriority = _interopRequireDefault(require("../actions/updateExperiencePriority"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { "default": obj };
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    function updateExperiencePriority(_ref) {
      var subtarget = _ref.subtarget,
          target = _ref.target;
      return function (dispatch) {
        return _ExperienceService["default"].updateExperiencePriority({
          body: {
            newPriority: target.priority,
            segmentsExperienceId: target.segmentsExperienceId
          },
          dispatch: dispatch
        }).then(function () {
          return dispatch((0, _updateExperiencePriority["default"])({
            subtarget: subtarget,
            target: target
          }));
        });
      };
    }
    //# sourceMappingURL=updateExperiencePriority.js.map
  }
});
//# sourceMappingURL=updateExperiencePriority.js.map