<%--
/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */
--%>

<%@ include file="/init.jsp" %>

<%
String navigationName = ParamUtil.getString(request, "navigationName");
%>

<c:if test="<%= Validator.isNotNull(navigationName) %>">
	<aui:nav-bar markupView="lexicon">
		<aui:nav cssClass="navbar-nav">
			<aui:nav-item label="<%= navigationName %>" selected="<%= true %>" />
		</aui:nav>
	</aui:nav-bar>
</c:if>